
// TODO
// - listing of broken links

var debug = false;

var yarnfilename;

function upload() {
	var loadform = document.getElementById('loadform');
    var yarnfile = document.getElementById('yarnfile');
	var	reader = FileReader();
	reader.onload = function() {
		uploadfinished(reader.result);
	};
	var file = yarnfile.files[0];
	if (!file) {
		alert('You must select a file to load.');
		return;
	}
	yarnfilename = file.name;
	reader.readAsText(file);
	loadform.style.display = 'none';
}

var header;
var passages;
var curpassage;

document.getElementById('newyarn').onclick = function()
{
	var pname = document.getElementById('name');
	var text = document.getElementById('text');

	passages = {
		'': '${\ninfo.title = "new game";\n$}',
		'start': 'Hello, World!',
	};

	curpassage = '';
	pname.value = '';
	text.value = passages[''];

	makelinks();

	document.getElementById('loadform').style.display = 'none';
	document.getElementById('table').style.display = 'table';
	
	return false;
}

document.getElementById('previewclose').onclick = function()
{
	document.getElementById('previewframe').src = 'about:blank';
	document.getElementById('preview').style.display = 'none';
	return false;
}


var textChangeID = null;

function textChange() {
	if (textChangeID != null)
		clearTimeout(textChangeID);
	textChangeID = setTimeout(function() {
		makelinks();
	}, 300);
}

document.getElementById('text').onchange = textChange;
document.getElementById('text').onkeyup = textChange;


document.getElementById('name').onfocus = cleardownload;
document.getElementById('text').onfocus = function() {
	cleardownload();
	savepassage();
	makelinks();
}

function uploadfinished(data)
{
	var pname = document.getElementById('name');
	var text = document.getElementById('text');

	if (!parseHTML(data))
		parseYarn(data);

	curpassage = '';
	pname.value = curpassage;
	text.value = passages[curpassage];

	makelinks();

	document.getElementById('table').style.display = 'table';
}

function makelinks()
{
	var links = document.getElementById('links');
	var adjlinks = document.getElementById('adjlinks');
	var html = '';

	var names = Object.keys(passages);
	names.sort();

	for (var i = 0; i < names.length; i++) {
		var n = names[i];
		if (n == '') n = '(header)';
		if (names[i] == curpassage)
			html += n + '<br>';
		else
			html += '<a href="#" id="link' + i + '">' + n + '</a><br>';
	}

	links.innerHTML = '<a href="#" id="newpassage">new passage</a><br><br>' + html;

	document.getElementById('newpassage').onclick = function() {
		savepassage();
		curpassage = findUniqueName('new passage');
		document.getElementById('name').value = curpassage;
		document.getElementById('text').value = '';
		savepassage();
		makelinks();
		return false;
	};

	for (var i = 0; i < names.length; i++) {
		if (names[i] == curpassage)
			continue;
		document.getElementById('link' + i).onclick = function(dest) {
			return function() {
				changepassage(dest);
				return false;
			};
		}(names[i]);
	}

	var adj = findLinks(document.getElementById('text').value);
	html = '';
	for (var i = 0; i < adj.length; i++) {
		switch (adj[i].type) {
		case 'text':
		case 'js':
		case 'display':
			var attrs = '';
			if (passages[adj[i].dest] == undefined)
				attrs += ' class="newpassage"';
			html += '<a' + attrs + ' href="#" id="adjlink' + i + '">' + adj[i].dest + '</a> (' + adj[i].type + ')<br>';
			break;

		default:
			html += adj[i].dest + ' (' + adj[i].type + ')<br>';
			break;
		}
	}
	adjlinks.innerHTML = html;
	for (var i = 0; i < adj.length; i++) {
		document.getElementById('adjlink' + i).onclick = function(dest) {
			return function() {
				changepassage(dest);
				return false;
			};
		}(adj[i].dest);
	}
}

function showpreview()
{
	savepassage();
	makelinks();

	var pdiv = document.getElementById('preview');
	var pframe = document.getElementById('previewframe');
	pdiv.style.display = 'block';

	var extrajs = '';
	extrajs += 'debug = true;\n';
	extrajs += 'loadcookie = false;\n';
	if (curpassage != '')
		extrajs += 'info.start = ' + JSON.stringify(curpassage) + ';\n';

	pframe.src = 'data:text/html;base64,' + btoa(makeHTML(extrajs));
}

function findUniqueName(name)
{
	var extra = '';
	var i = 1;
	while (passages[name + extra]) {
		i++;
		extra = i.toString();
	}
	return name + extra;
}

function savepassage()
{
	var pname = document.getElementById('name');
	var text = document.getElementById('text');

	pname.value = pname.value.trim();
	if (curpassage != pname.value) {
		// it was renamed

		// make sure we don't clobber another passage
		pname.value = findUniqueName(pname.value);

		passages[pname.value] = text.value;
		delete passages[curpassage];
		curpassage = pname.value;

	} else {
		passages[pname.value] = text.value;
	}
}

function changepassage(dest)
{
	var pname = document.getElementById('name');
	var text = document.getElementById('text');

	savepassage();

	// load dest passage
	curpassage = dest;
	pname.value = dest;
	if (passages[dest] != undefined)
		text.value = passages[dest];
	else {
		text.value = '';
		savepassage();
	}

	makelinks();
}

function deletepassage()
{
	savepassage();
	if (curpassage == '') {
		alert('You cannot delete the header passage.');
		return;
	}
	if (confirm('Really delete "' + curpassage + '"?')) {
		delete passages[curpassage];

		// change passage to the header without saving
		curpassage = '';
		document.getElementById('name').value = curpassage;
		document.getElementById('text').value = passages[curpassage];
	}
	makelinks();
}

function makedownload()
{
	var a;

	savepassage();
	document.getElementById('savebtn').style.display = 'none';
	if (!yarnfilename)
		yarnfilename = 'newgame.html';

	a = document.getElementById('downloadhtml');
	a.download = yarnfilename;
	a.href = 'data:text/plain;base64,' + btoa(makeHTML());

	document.getElementById('downloads').style.display = 'inline';
}

function cleardownload()
{
	var a;

	a = document.getElementById('downloads');
	a.style.display = 'none';

	a = document.getElementById('downloadhtml');
	a.href = 'about:blank';

	document.getElementById('savebtn').style.display = 'inline';
}

if (!debug)
	window.onbeforeunload = function(e) {
		return 'Leaving the page will cause your work to be lost. Are you sure?';
	};
// window.onbeforeunload = null;
