var htmltemplate = "<!doctype html>\n<html><head>\n<meta charset=\"utf8\" />\n<style>\n\nbody {\n\tcolor: #ddd;\n\tbackground-color: #333;\n\tfont-family: \"DejaVu Sans\", \"Verdana\", sans-serif, sans;\n}\n\n#center {\n\tmargin-left: auto;\n\tmargin-right: auto;\n\tmax-width: 600px;\n}\n\n#menu {\n\tborder-bottom: 1px solid #666;\n\tpadding: 20px;\n}\n\n.menuitem {\n\tdisplay: inline-block;\n\tpadding-right: 25px;\n}\n\n.menuitem.author {\n\tfont-size: small;\n}\n\n.menuitem.madewith {\n\tfont-size: small;\n\tfloat: right;\n\tpadding-right: 0;\n}\n\n#debug {\n\tposition: absolute;\n\tleft: 10px;\n\tbottom: 10px;\n}\n\n#page {\n\tmargin-bottom: 50px;\n\tpadding: 20px;\n\tpadding: 20px;\n}\n\na {\n\tcolor: #4D6AD8;\n\tfont-weight: bold;\n\ttext-decoration: none;\n}\n\na:hover {\n\tcolor: #8EA6FF;\n\ttext-decoration: underline;\n}\n\nimg {\n\tmax-width: 100%;\n}\n\n</style>\n</head><body>\n<div id=\"center\">\n<div id=\"menu\"></div>\n<div id=\"page\"></div>\n<div id=\"debug\"></div>\n</div>\n<script>\n/* cookies.js */\n// from http://www.quirksmode.org/js/cookies.html\n\nfunction createCookie(name,value,days) {\n\tif (days) {\n\t\tvar date = new Date();\n\t\tdate.setTime(date.getTime()+(days*24*60*60*1000));\n\t\tvar expires = \"; expires=\"+date.toGMTString();\n\t}\n\telse var expires = \"\";\n\tdocument.cookie = name+\"=\"+escape(value)+expires+\"; path=/\";\n}\n\nfunction readCookie(name) {\n\tvar nameEQ = name + \"=\";\n\tvar ca = document.cookie.split(';');\n\tfor(var i=0;i < ca.length;i++) {\n\t\tvar c = ca[i];\n\t\twhile (c.charAt(0)==' ') c = c.substring(1,c.length);\n\t\tif (c.indexOf(nameEQ) == 0) return unescape(c.substring(nameEQ.length,c.length));\n\t}\n\treturn null;\n}\n\nfunction eraseCookie(name) {\n\tcreateCookie(name,\"\",-1);\n}\n\n/* yarn.js */\n\nvar debug = false;  // make true to enable some debug features\nvar initerror = 0;  // 0 = before loading game, 1 = init error, 2 = game loaded\nvar loadcookie = true;  // set false to disable savegame loading (useful for debugging)\n\nvar info = {\n\t//title: '',\n\t//author: '',\n\tstart: 'start',\n\trestart: true,\n\tversion: 0,\n};\nvar save = {};\nvar _save = {lines: []};\nvar passage = {};\n\nvar linksilly = false;  // if set true, links are of the form [[display text|destination]] (twine) instead of the normal [[destination|display text]] (wikipedia)\n\nvar fadeTick = 1000 / 30;\nvar fadeLength = .4;\n\nvar fadeAmount;\nfunction startFade()\n{\n\tfadeAmount = 0;\n\tcontinueFade();\n}\nfunction continueFade()\n{\n\tfadeAmount += (fadeTick / 1000) / fadeLength;\n\tif (fadeAmount > 1) fadeAmount = 1;\n\n\tvar page = document.getElementById('page');\n\tpage.style.opacity = fadeAmount;\n\tif (fadeAmount < 1)\n\t\tsetTimeout(continueFade, fadeTick);\n}\n\nfunction menuClear()\n{\n\tdocument.getElementById('menu').innerHTML = '';\n}\nfunction menuAdd(html, cls)\n{\n\tvar menu = document.getElementById('menu');\n\tvar div = document.createElement('div');\n\tdiv.className = 'menuitem';\n\tif (cls) div.className += ' ' + cls;\n\tdiv.innerHTML = html;\n\tmenu.appendChild(div);\n}\n\nfunction menuAddRestart()\n{\n\tmenuAdd('<a href=\"#\" id=\"menu_restart\">restart</a>');\n\n\tdocument.getElementById('menu_restart').onclick = function() {\n\t\tif (debug || confirm('Really erase all progress and start over?'))\n\t\t\tdeleteGame();\n\t\treturn false;\n\t};\n}\nfunction menuUpdateDebug()\n{\n\tvar dbg = document.getElementById('debug');\n\tvar html = '';\n\n\thtml += '<p><form><input id=\"debug_goto\" value=\"' + _save.passage + '\"><input type=\"submit\" value=\"goto\" id=\"debug_gotobutton\"></form>';\n\n\thtml += '<p>';\n\tfor (var name in save) {\n\t\tif (!name.search(/_/) == 0)\n\t\t\thtml += name + ' = ' + JSON.stringify(save[name]) + '<br>';\n\t}\n\n\tdbg.innerHTML = html;\n\n\tdocument.getElementById('debug_gotobutton').onclick = function() {\n\t\tgotoPassage(document.getElementById('debug_goto').value);\n\t\treturn false;\n\t};\n}\n\nfunction getCookieName()\n{\n\treturn 'yarnsave_' + escape(info.title) + info.version.toString();\n}\n\nfunction saveGame()\n{\n\tvar s = {save: save, _save: _save};\n\tcreateCookie(getCookieName(), JSON.stringify(s), 365 * 3);\n}\n\nfunction loadGame()\n{\n\tvar data = readCookie(getCookieName());\n\tif (data) {\n\t\tvar s = JSON.parse(data);\n\t\tsave = s.save;\n\t\t_save = s._save;\n\t\treturn true;\n\t} else return false;\n}\n\nfunction deleteGame()\n{\n\teraseCookie(getCookieName());\n\tlocation.reload(true);\n}\n\nfunction display(name)\n{\n\tvar p = passage[name];\n\n\tif (p) {\n\t\ttry {\n\t\t\tp();\n\t\t} catch (e) {\n\t\t\tshowError(e, name);\n\t\t}\n\n\t} else {\n\t\twrite('<b>ERROR</b>: Missing passage \"' + name + '\"');\n\t}\n}\n\nwindow.onerror = function(msg, url, line)\n{\n\tif (initerror == 0)\n\t\tiniterror = 1;\n\tvar e = {\n\t\tname: msg.split(/:/)[0],\n\t\tmsg: msg.split(/:/)[1],\n\t\tfileName: url,\n\t\tlineNumber: line,\n\t};\n\tshowError(e);\n}\n\nfunction showError(e, passageName)\n{\n\twrite('<b>ERROR</b>: Script failed.');\n\tif (debug || initerror == 1) {\n\t\tif (passageName)\n\t\t\twrite('(in passage \"' + passageName + '\")');\n\t\twrite(e.name + ': ' + e.msg);\n\t\tif (e.fileName.search(/data:/) == 0)\n\t\t\te.fileName = e.fileName.substring(0, 32) + '...';\n\t\twrite('line ' + e.lineNumber + ' in ' + e.fileName);\n\t\twrite();\n\t\twrite('The following may be offset, but is probably useful:');\n\t\tvar doclines = document.firstElementChild.outerHTML.split(/\\n/);\n\t\tfor (var x = -2; x <= 2; x++) {\n\t\t\t// -2 = -1 (because line 1 is element 0) -1 (doctype isn't included in html tag's outerhtml)\n\t\t\tvar s = (e.lineNumber + x) + ': ' + doclines[e.lineNumber - 2 + x];\n\t\t\tif (x == 0) s = '<b>' + s + '</b>';\n\t\t\twrite(s);\n\t\t}\n\t}\n}\n\nfunction startGame()\n{\n\tif (initerror == 1)\n\t\treturn;\n\tiniterror = 2;\n\n\t// build menu\n\tif (info.title)\n\t\tmenuAdd(info.title, 'title');\n\tif (info.author)\n\t\tmenuAdd('by ' + info.author, 'author');\n\n\tif (info.restart)\n\t\tmenuAddRestart();\n\n\tmenuAdd('made with <a href=\"http://raincomplex.net/yarn\">yarn</a>', 'madewith');\n\t\n\t// load or start new game\n\tif (loadcookie && loadGame())\n\t\tshowFromSave();\n\telse\n\t\tgotoPassage(info.start);\n}\n\nfunction showFromSave()\n{\n\tvar lines = _save.lines;\n\tclear();\n\n\twrite('<small>(loaded from save cookie)</small>\\n');\n\tfor (var i = 0; i < lines.length; i++)\n\t\twrite(lines[i]);\n\n\tstartFade();\n\tif (debug) menuUpdateDebug();\n}\n\nfunction gotoPassage(dest)\n{\n\tclear();\n\n\t_save.passage = dest;\n\tdisplay(dest);\n\tsaveGame();\n\n\tstartFade();\n\tif (debug) menuUpdateDebug();\n}\n\nvar linkid = 0;\n\nfunction clear()\n{\n\tlinkid = 0;\n\t_save.lines = [];\n\n\tvar page = document.getElementById('page');\n\tpage.style.opacity = 0;\n\tpage.innerHTML = '';\n}\n\nfunction write(line)\n{\n\t// if line is an array, recurse on each element\n\tif (Array.isArray(line)) {\n\t\tfor (var i = 0; i < line.length; i++)\n\t\t\twrite(line[i]);\n\t\treturn;\n\t}\n\n\tif (!line)\n\t\tline = '';\n\n\tif (line.search(/\\n/) != -1) {\n\t\twrite(line.split(/\\n/g));\n\t\treturn;\n\t}\n\t\n\t// store the line in case we need to load this passage\n\t_save.lines.push(line);\n\n\tvar page = document.getElementById('page');\n\n\t// replace [[link]]s with <a>s\n\tvar makelinks = [];\n\tfunction repl(match, text) {\n\t\tlinkid++;\n\t\tvar link = {\n\t\t\tid: 'link' + linkid,\n\t\t\tdest: text,\n\t\t};\n\t\tvar pipe = text.search(/\\|/);\n\t\tif (pipe != -1) {\n\t\t\tif (!linksilly) {\n\t\t\t\tlink.dest = text.substring(0, pipe);\n\t\t\t\ttext = text.substring(pipe + 1);\n\t\t\t} else {\n\t\t\t\tlink.dest = text.substring(pipe + 1);\n\t\t\t\ttext = text.substring(0, pipe);\n\t\t\t}\n\t\t}\n\t\tmakelinks.push(link);\n\t\treturn '<a href=\"#\" id=\"' + link.id + '\">' + text + '</a>';\n\t}\n\tline = line.replace(/\\[\\[(.*?)\\]\\]/g, repl);\n\n\t// make sure the line takes up at least one line's worth of vertical space\n\tline += '<br>';\n\n\t// add the line to the page\n\tvar div = document.createElement('div');\n\tdiv.innerHTML = line;\n\tpage.appendChild(div);\n\n\t// add onclicks to <a>s\n\tfor (var i = 0; i < makelinks.length; i++) {\n\t\tdocument.getElementById(makelinks[i].id).onclick = function(link) {\n\t\t\treturn function() {\n\t\t\t\tgotoPassage(link.dest);\n\t\t\t\treturn false;\n\t\t\t}\n\t\t}(makelinks[i]);\n\t}\n}\n\nfunction randint(a, b)\n{\n\treturn Math.floor(a + Math.random() * (b - a + 1));\n}\n\nfunction setColors(fg, bg)\n{\n\tdocument.body.style.color = fg;\n\tdocument.body.style.backgroundColor = bg;\n}\n\n/* game */\n$GAME\nstartGame();\n</script>\n</body></html>\n";
if (exports) { exports.htmltemplate = htmltemplate; }
